#!/bin/bash

#############
# VARIABLES #
#############
ADML_INSTANCES=`cat .st_conf_adml_instances 2>/dev/null`

#############
# FUNCTIONS #
#############
_exit() {
  echo
  echo $1
  echo
  exit 1
}

#############
# EXECUTION #
#############
echo
echo
cd `dirname $0`
./checkStatus.sh
[ $? -ne 0 ] && _exit "Fix status to continue ..."
echo
echo "Input desired rate (test cases per second) to start testing [0: stop if active]:"
read desired_rate
if [ "$desired_rate" != "" ]
then
  rate_per_instance=$((desired_rate/$ADML_INSTANCES))
fi

echo
echo "As we have $ADML_INSTANCES instances available, we shall launch $rate_per_instance test cases"
echo " per second and instance (./operation.sh \"test|ttps|$rate_per_instance\")."
echo
echo "Press ENTER to continue, CTRL-C to abort ..."
read dummy
./operation.sh "test|ttps|$rate_per_instance"

