// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_diameter_helpers_nokia_defines_hpp
#define anna_diameter_helpers_nokia_defines_hpp


// Local
#include <anna/diameter/helpers/defines.hpp>

// STL
#include <string>


/** Contextualized definitions (avp id) */
#define anna_diameter_helpers_define_avp(avpname,code)  anna_diameter_helpers_define_avp_in_context(avpname,code,nokia)

/** Contextualized definitions (avp id and values) */
#define anna_diameter_helpers_define_avp_with_values(avpname,code)  anna_diameter_helpers_define_avp_with_values_in_context(avpname,code,nokia)


namespace anna {

namespace diameter {

namespace helpers {

namespace nokia {


/**
* Avps
*/
anna_diameter_helpers_define_avp(Nokia_Access_Method, 5100);
anna_diameter_helpers_define_avp(Nokia_IMS_Media_Component_Id, 5101);
anna_diameter_helpers_define_avp_with_values(Nokia_Reporting_Reason, 5102) {
  enum v_ {
    QHT = 1,
    TERMINATED = 2,
    VALIDITY_TIME = 3,
    CHANGED_QOS = 4,
    CHANGED_SGSN = 5,
    CHANGED_RAT = 6,
    FORCED_REAUTHORIZATION = 7,
    CREDIT_POOL_EXHAUSTED = 8,
    EXHAUSTED_TIME = 9,
    EXHAUSTED_TOTAL_OCTETS = 10,
    EXHAUSTED_INPUT_OCTETS = 11,
    EXHAUSTED_OUTPUT_OCTETS = 12,
    EXHAUSTED_SERVICE_SPECIFIC_UNITS = 13
  };
};

anna_diameter_helpers_define_avp(Time_Of_First_Usage, 5103);
anna_diameter_helpers_define_avp(Time_Of_Last_Usage, 5104);
anna_diameter_helpers_define_avp(Session_Start_Indicator, 5105);
anna_diameter_helpers_define_avp(Rule_Base_Id, 5106);
anna_diameter_helpers_define_avp(Trigger, 5107);
anna_diameter_helpers_define_avp_with_values(Trigger_Type, 5108) {
  enum v_ {
    CHANGE_IN_SGSN_IP_ADDRESS = 1,
    CHANGE_IN_QOS_ANY = 2,
    CHANGE_IN_RAT = 3
  };
};

anna_diameter_helpers_define_avp(Quota_Holding_Time, 5110);
anna_diameter_helpers_define_avp(Default_Quota, 5111);


/**
* Commands
*/


}
}
}
}


#undef anna_diameter_helpers_define_avp
#undef anna_diameter_helpers_define_avp_with_values

#endif

