// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_http_Method_hpp
#define anna_http_Method_hpp

#include <string>

#include <anna/config/defines.hpp>
#include <anna/core/define.autoenum.hpp>

namespace anna {

namespace http {

class Token;

/**
   Metodos utilizados para realizar peticiones HTTP.
*/
class Method {
public:
  /**
     Tipos de peticiones definidos en la RFC 2616
     \see Method
  */
  struct Type {
    enum _v {
      None = -1, Post, Options, Get, Head, Put, Delete, Trace, Connect
    };
    anna_declare_enum(Type);
  };

  /**
     Interpreta el token recibido como parametro y devuelve el valor de Type con el
     que esta asociado.
     \param token Token obtenido en la fase de analisis.
     \warning Exclusivamente uso interno.
     \return El tipo de metodo.
  */
  static Type::_v asType(const Token* token) throw();

  /**
     Devuelve el nombre del metodo con el que esta asociado el tipo recibido.
     \param type Tipo de metodo.
     \return el nombre del metodo con el que esta asociado el tipo recibido.
  */
  static std::string asString(const Type::_v type) throw();

private:
  Method() {;}
};


}
}

#endif
