// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_timex_internal_TickProducer_hpp
#define anna_timex_internal_TickProducer_hpp

#include <anna/core/mt/Runnable.hpp>

namespace anna {

namespace timex {

class Engine;

/**
 * Esta clase se ejecuta desde un thread 'real' aunque estemos generando la librera en modo ST,
 * para evitar que la librera tenga que generar pulso de reloj mediante el SIGALRM.
 */
class TickProducer {
public:
  void requestStop() throw() { a_requestedStop = true; }

  // Para poder clonarlo
  void setfd(const int fd) throw() { a_fdWrite = fd; }

private:
  Engine& a_timeController;
  int a_fdWrite;
  Millisecond a_expectedTime;
  bool a_isInPause;
  bool a_requestedStop;

  TickProducer(Engine* timeController, const int fdWrite);

  bool isInPause() const throw() { return a_isInPause; }
  void setIsInPause(const bool isInPause) throw() { a_isInPause = isInPause; }

  void tick() throw();
  void resetExpectedTime() throw() { a_expectedTime = 0; }
  Millisecond calculeSlice(const Millisecond & msnow) throw();

  static void* exec(void* arg) throw();

  friend class Engine;
};

}
}

#endif
