// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#include <anna/core/tracing/Logger.hpp>
#include <anna/core/tracing/TraceMethod.hpp>
#include <anna/core/DataBlock.hpp>
#include <anna/comm/Message.hpp>
#include <anna/comm/Server.hpp>

#include <anna/diameter.comm/ClientSessionReceiver.hpp>
#include <anna/diameter.comm/ClientSession.hpp>
#include <anna/diameter.comm/Server.hpp>
#include <anna/core/functions.hpp>

// STL
#include <string>


using namespace anna::diameter::comm;

void ClientSessionReceiver::apply(anna::comm::ClientSocket& clientSocket, const anna::comm::Message& message)
throw(anna::RuntimeException) {
  LOGMETHOD(anna::TraceMethod tm("diameter.comm.ClientSessionReceiver", "apply", ANNA_FILE_LOCATION));
  a_session->receive(message);
}

void ClientSessionReceiver::eventBreakConnection(const anna::comm::ClientSocket& clientSocket)
throw() {
  LOGMETHOD(anna::TraceMethod tm("diameter.comm.ClientSessionReceiver", "eventBreakConnection", ANNA_FILE_LOCATION));
  a_session->finalize();
}

void ClientSessionReceiver::eventCreateConnection(const anna::comm::Server* server)
throw() {
  LOGMETHOD(anna::TraceMethod tm("diameter.comm.ClientSessionReceiver", "eventCreateConnection", ANNA_FILE_LOCATION));
  a_session->recover();
}

