// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include <anna/core/tracing/Logger.hpp>
#include <anna/core/tracing/TraceMethod.hpp>
#include <anna/config/defines.hpp>

#include <libxml/parser.h>

#include <anna/xml/DTDFile.hpp>

using namespace std;
using namespace anna;
using namespace anna::xml;

_xmlDtd* DTDFile::parse(const char *filename) const
throw(RuntimeException) {
  LOGMETHOD(TraceMethod tf("anna::xml::DTDFile", "parse", ANNA_FILE_LOCATION));
  _xmlDtd* result;
  int stream;
  LOGDEBUG(Logger::write(Logger::Debug, "Analyzing DTD file", filename, ANNA_FILE_LOCATION));

  if((stream = open(filename, O_RDONLY)) == -1)
    throw RuntimeException(string(filename), errno, ANNA_FILE_LOCATION);

  close(stream);

  if((result = xmlParseDTD(NULL, BAD_CAST(filename))) == NULL)
    throw RuntimeException("DTD is wrong", ANNA_FILE_LOCATION);

  return result;
}

